/**
 * @jest-environment jsdom
 */

import ProposalSystemInfoEntry from "$lib/components/proposal-detail/ProposalSystemInfoEntry.svelte";
import { render, waitFor } from "@testing-library/svelte";
import en from "../../../mocks/i18n.mock";

describe("ProjectSystemInfoEntry", () => {
  it("should render a description placeholder if no description", async () => {
    const renderResult = render(ProposalSystemInfoEntry, {
      props: {
        labelKey: "test",
        testId: "test",
        value: "",
        description: undefined,
      },
    });

    const { getByTestId } = renderResult;
    await waitFor(() =>
      expect(getByTestId(`test-description`)?.textContent).toEqual(
        en.proposal_detail.no_more_info
      )
    );
  });
});
